'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils');

var _Zoom = require('./Zoom');

var _Zoom2 = _interopRequireDefault(_Zoom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventsWrapper = function (_Component) {
  _inherits(EventsWrapper, _Component);

  function EventsWrapper() {
    _classCallCheck(this, EventsWrapper);

    var _this = _possibleConstructorReturn(this, (EventsWrapper.__proto__ || Object.getPrototypeOf(EventsWrapper)).call(this));

    setTimeout(_this._renderZoomed.bind(_this), 0);
    _this.unzoom = _this.unzoom.bind(_this);
    return _this;
  }

  _createClass(EventsWrapper, [{
    key: 'render',
    value: function render() {
      return null;
    }
  }, {
    key: '_renderZoomed',
    value: function _renderZoomed() {
      var _this2 = this;

      var _props = this.props,
          items = _props.items,
          image = _props.image,
          onUnzoom = _props.onUnzoom,
          activeIndex = _props.activeIndex;

      this.portal = (0, _utils.createPortalContainer)('div');
      _reactDom2.default.render(_react2.default.createElement(
        'div',
        { style: {
            overflowY: 'hidden'
          }, onClick: this.unzoom },
        _react2.default.createElement(_Zoom2.default, { ref: function ref(child) {
            return _this2.child = child;
          }, activeIndex: activeIndex, items: items, image: image, onUnzoom: onUnzoom })
      ), this.portal);
    }
  }, {
    key: 'unzoom',
    value: function unzoom() {
      var _this3 = this;

      this.props.onUnzoom();
      if (this.portal) {
        setTimeout(function () {
          _reactDom2.default.unmountComponentAtNode(_this3.portal);
          (0, _utils.removePortalContainer)(_this3.portal);
          delete _this3.portal;
        }, 300);
      }
      return this.child.unzoom();
    }
  }]);

  return EventsWrapper;
}(_react.Component);

exports.default = EventsWrapper;

EventsWrapper.propTypes = {
  activeIndex: _propTypes2.default.number,
  image: _propTypes2.default.object,
  onUnzoom: _propTypes2.default.func
};