'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var cn = exports.cn = function cn(className) {
  return typeof className === 'string' ? className.split('.').join(' ').trim() : '';
};
var createPortalContainer = exports.createPortalContainer = function createPortalContainer(tag) {
  var portal = document.createElement(tag);
  document.body.appendChild(portal);
  return portal;
};
var removePortalContainer = exports.removePortalContainer = function removePortalContainer(portal) {
  document.body.removeChild(portal);
};
var transitionDuration = exports.transitionDuration = 300;